unit yesylib2;

interface

const max=1024*1024*3;
      maxy=15*1024;
      maxx=10*1024;

type rgbs=array[1..3] of byte;
     arrgb=array[1..Maxx] of rgbs;
     parrgb=^arrgb;

     myi=record
       Pix:array[1..maxy] of parrgb;
       x,y:integer;
     end;

  procedure getim(n:string;var a:myi);
  procedure FreeIma(var a:myi);

implementation

  uses windows, sysutils, graphics, jpeg, ExtCtrls;

  var BB:TBitmap;
      Image1:TImage;

  procedure FreeIma(var a:myi);
    var i:integer;
    begin
      for i:=1 to a.y do freemem(a.pix[i],a.x);
    end;

  procedure ToYUV(var r,y:rgbs);
    var k,l,m:integer;
    begin
      k:=round(r[1]*0.299+r[2]*0.587+r[3]*0.114);
      l:=128+round(-r[1]*0.1687-r[2]*0.3313+r[3]*0.5);
      m:=128+round(r[1]*0.5-r[2]*0.4187-r[3]*0.0813);
      if k<0 then k:=0 else if k>255 then k:=255;
      if l<0 then l:=0 else if l>255 then l:=255;
      if m<0 then m:=0 else if m>255 then m:=255;
      y[1]:=k;y[2]:=l;y[3]:=m;
     end;

  procedure getim(n:string;var a:myi);
    type dat3=array[1..100000,1..3] of byte;
    var i,j,k:integer;
        z:tcolor;
        d3:^dat3;
    procedure BadIm;
      var i,j,k:integer;
      begin
        a.x:=256;a.y:=256;
        for i:=1 to a.y do GetMem(a.pix[i],a.x*3);
        for i:=1 to a.y do for j:=1 to a.x do for k:=1 to 3 do
          a.pix[i,j,k]:=255;
      end;
    begin
      try
        Image1.Picture.LoadFromFile(n);
      except
        BadIm;
        exit;
      end;  
      BB:=TBitmaP.Create;
      try
        BB.Assign(Image1.Picture.Graphic);
      except
        bb.free;
        BadIm;
        exit;
      end;  
        
      a.x:=BB.Width;a.y:=BB.Height;
      for i:=1 to a.y do GetMem(a.pix[i],a.x*3);

      if bb.PixelFormat<>pf24bit then
        for i:=1 to a.y do for j:=1 to a.x do
          begin
            z:=BB.canvas.Pixels[j-1,i-1];
            a.pix[i,j,3]:=(z mod (256*256*256))div (256*256);
            a.pix[i,j,2]:=(z mod (256*256))div 256;
            a.pix[i,j,1]:=z mod 256;
          end
      else
        for i:=1 to a.y do
          begin
            d3:=BB.ScanLine[i-1];
            for j:=1 to a.x do for k:=1 to 3 do
              a.pix[i,j,k]:=d3[j,4-k];
          end;

      for i:=1 to a.y do for j:=1 to a.x do ToYUV(a.pix[i,j],a.pix[i,j]);
      (* a[i,j,1] - brightness of pixel i,j *)
      BB.Free;
    end;
begin
  Image1:=TImage.Create(nil);
end.
